
/* Generated by Interface Builder */

#import <AppKit/AppKit.h>
#import <math.h>

#define PI					3.14159
#define CUBESIZE 0.9
#define TETRAHEDRONSIZE	1.3
#define TETRAHEDRON4SIZE	1.3
#define OCTAHEDRONSIZE	1.15
#define OCTAHEDRON4SIZE	1.15
#define DODECAHEDRONSIZE	0.7
#define ICOSAHEDRONSIZE	1.25
#define CELL24SIZE			0.80
#define CELL120SIZE			1.3
#define CELL600SIZE			1.3
#define MAXVERTICES		600
#define MAXLINES			1200
#define DIMENSION			4
#define SIZE					50.0
#define DELAY				0.5
#define INTERVAL				0.2
#define TETRAHEDRON		1
#define CUBE					2
#define OCTAHEDRON		3
#define DODECAHEDRON		4
#define ICOSAHEDRON		5
#define TETRAHEDRON4		6
#define CUBE4				7
#define OCTAHEDRON4		8
#define CELL24				9
#define CELL120				10
#define CELL600				11
#define	XYROT	1
#define YZROT	2
#define ZXROT	3
#define XWROT	4
#define YWROT	5
#define	ZWROT	6
#define CELLBLACK	0
#define CELLRED		1
#define CELLGREEN	2
#define CELLBLUE	3
#define	CELLCYAN	4
#define CELLMAGENTA	5
#define CELLYELLOW	6

@interface MyView:NSView
{
	BOOL		timerActive;
	NSTimer		*rotateTimer;
	int		whichRotation;
	int		LR;

	id		SizeBar;
	id		XYButton, XZButton, YZButton;
	id		XWButton, YWButton, ZWButton;
	id		MyBox;
	id		RotateAdjust;
IBOutlet	id		FrontBack;
IBOutlet	id		CellRadio;
IBOutlet    id	WhichCell;
	int		figure;
	int		vertices;
	int		lines;
	int		cells;
	int		cellcolor;
	int		selectedcell;
	double	cube[MAXVERTICES][DIMENSION];
	int		startline[MAXLINES];
	int		endline[MAXLINES];
	int		background;  /*0 = white; 1 = ltgray; 2 = dkgray; 3 = black */
	BOOL	withperspective;
	double	distance;
	double	clarge, slarge, csmall, ssmall;
	double 	C, S;
	BOOL	madefirstresponder;
}

- initWithFrame:(NSRect)frameRect;
- (void)drawLine:(int)i;
-determineLine:(int)i : (NSPoint*)startPt :(NSPoint *)endPt;
- (void)drawRect:(NSRect)rects;
- (void)initializeTetrahedron;
- (void)initializeCube;
- (void)initializeOctahedron;
- (void)initializeDodecahedron;
- (void)initializeIcosahedron;
- (void)initialize4Tetrahedron;
- (void)initialize4Cube;
- (void)initialize4Octahedron;
- (void)initialize24Cell;
- (void)initialize120Cell;
- (void)initialize600Cell;
- (void)copy:(id)sender;
-(BOOL) acceptsFirstResponder;
- (void)XW:sender;
- (void)YZ:sender;
- (void)XZ:sender;
- (void)ZW:sender;
- (void)XY:sender;
- (void)YW:sender;
- (IBAction)SetWhite:sender;
- (IBAction)SetLtGray:sender;
- (IBAction)SetDkGray:sender;
- (IBAction)SetBlack:sender;
- (void)SetAngle:(int)leftright :(int)slowfast; - (void)SetTetrahedron:sender;
- (IBAction)SetCube:sender;
- (IBAction)SetOctahedron:sender;
- (IBAction)SetDodecahedron:sender;
- (IBAction)SetIcosahedron:sender;
- (IBAction)Set4Tetrahedron:sender;
- (IBAction)Set4Cube:sender;
- (IBAction)Set4Octahedron:sender;
- (IBAction)Set24Cell:sender;
- (IBAction)Set120Cell:sender;
- (IBAction)Set600Cell:sender;
- (IBAction)ChangeCell:sender;
- (IBAction)ChangeCellColor:sender;
- (IBAction)ChangeCellState:sender;
- (IBAction)ChangeCellNumber:sender;
- (int) CheckCellValue:(int)thevalue;
- (void)FixBoxTitle;
- (void)FixFor3D;
- (void)FixFor4D;
- (void)ReDraw:sender;
- (void)DrawCell;
- (void)Initialize:sender;
- (IBAction)AdjustP:sender;
- (IBAction)AdjustDistance:sender;
- (void)doRotate;
- (void)handler1:(NSTimer *)Timer;
@end

